#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 2A.soft - Convert a notebook into a document
# 
# A couple of tricks to convert notebook such as convert a notebook into RST or HTML, get the notebook name.

# First, let's retrieve the notebook name (see [How to I get the current IPython Notebook name](http://stackoverflow.com/questions/12544056/how-to-i-get-the-current-ipython-notebook-name)):

# In[1]:


get_ipython().run_cell_magic('javascript', '', 'var kernel = IPython.notebook.kernel;\nvar body = document.body,  \n    attribs = body.attributes;\nvar command = "theNotebook = " + "\'"+attribs[\'data-notebook-name\'].value+"\'";\nkernel.execute(command);\n')


# In[2]:


if "theNotebook" in locals():
    a = theNotebook
else:
    a = None
a


# On Windows, you might need to execute the following trick (see [Pywin32 does not find its DLL](http://www.xavierdupre.fr/blog/2014-07-01_nojs.html)).

# In[3]:


import sys
if sys.platform.startswith("win"):
    from pyquickhelper.helpgen.utils_pywin32 import import_pywin32
    import_pywin32()


# Then, we call the following code:

# In[4]:


from nbconvert import HTMLExporter
exportHtml = HTMLExporter()
if a is not None:
    body,resources = exportHtml.from_filename(theNotebook)
    with open("conv_notebook.html", "w", encoding="utf8") as f: 
        f.write(body)


# We can do it with the RST format (see [RSTExporter](https://nbconvert.readthedocs.io/en/latest/api/exporters.html?highlight=rstexporter#nbconvert.exporters.RSTExporter)).

# In[5]:


from nbconvert import RSTExporter
exportRst = RSTExporter()
if a is not None:
    body,resources = exportRst.from_filename(theNotebook)
    with open("conv_notebook.rst", "w", encoding="utf8") as f: 
        f.write(body)


# Finally, if you want to retrieve the download a local file such as the RST conversion for example:
# 
# <!--RST ..index:: FileLink !RST-->

# In[6]:


from IPython.display import FileLink
FileLink("conv_notebook.rst")


# And the second link:

# In[7]:


FileLink("conv_notebook.html")


# In[8]: